/**	
 *   		    Finds all roots of polynomial by first finding quadratic
 *             factors using Bairstow's method, then extracting roots
 *             from quadratics. Implements new algorithm for managing
 *             multiple roots.
 *
 * \file rroots.h
 * \date (C) 2002, 2003, 
 * \author C. Bond. All rights reserved.
 */

#include <iostream>
#include <iomanip>
#include <math.h>
#include <stdlib.h>

#ifndef rroots_H
#define rroots_H

using namespace std;

/// maximum number of iterations
#define maxiter 5000
/// some other epsilon and stuff
#ifndef DBL_EPSILON
#define DBL_EPSILON 1e-15
#endif

/// Extract individual real or complex roots from list of quadratic factors
int roots(double *a,int n,double *wr,double *wi);

/// Top level routine to manage the determination of all roots of the given
/// polynomial 'a', returning the quadratic factors (and possibly one linear
/// factor) in 'x'. 
void get_quads(double *a,int n,double *quad,double *x);


#endif
