/**
 * \file AdditionalSourcesAndLosses.h
 * Sources and losses calculation
 *
 * \author Developed under supervision of the PI Yuri Shprits
 */

// Additional Sources or Losses (
/// \todo Move loss cone losses to the rest of the sources and losses
// Well... It needs to be 4D array, so it's 1d array of 3d arrays.

#ifndef SourcesAndLosses_H
#define SourcesAndLosses_H

#include "../Matrix/Matrix.h"
#include "../Parameters/Parameters.h"
#include "../Grid/Grid.h"

/**
 * \brief Calculates any additional sources and losses due to magnetopause.
 *
 */
class AdditionalSourcesAndLosses  {
private:
	double timeStep;

public:

    /// array of sources and losses values
	Matrix3D<double> arr;
	void Update(int iteration, Parameters_structure::SL_structure &SL, Grid &grid);
	void Create_SL(Parameters_structure::SL_structure &SL, Grid &grid, int numberOfIterations, double timeStep);
	double drift_time(double pc, double alpha, double L);

};


#endif
