/**
 * \file Output.cpp
 * \brief Logging and screen output function defenitions. see namespace Output for details
 *
 * \todo 
 * - Rewrite type conversion functions as "any to string" and organize them.
 * - Move all headers to the header files and code to cpp files (if it is possible everywhere).
 * - Rewrite all output with streams insted of old-c functions.
 *
 * \author Developed by Dmitry Subbotin under supervision of the PI Yuri Shprits
 */

#include "Output.h"

namespace Output {

	/// \brief stream for log file defined in namespase Output
	ofstream log_file;

	/// \brief verbose level defined in namespase Output
	int outputLvl = 0;

	void open_log_file(string filename){
		log_file.open(filename.c_str(), ios::out);
		if (log_file == NULL) {
			char buffer[1024];
			strcpy(buffer, "error open file for output");
			throw error_msg("FOPEN", "%s", buffer);
		}
	}

	void close_log_file(){
		log_file.close();
	}

	void flush_log_file(){
		log_file.flush();
	}

	void set_output_lvl(int new_outputLvl){
		outputLvl = new_outputLvl;
	}

	void echo(int msglvl, const char * format , ... ) {
		if (outputLvl >= msglvl) {
			int len;
			va_list args;
			va_start( args, format );
			char *buffer = new char[1024];

			len = vsnprintf(buffer, 1024, format, args ) + 1;
			if (len == 0) throw error_msg("OUTPUT", "Output does not work :-(");

			(log_file) << buffer;
			cout << buffer;

			delete buffer;
		} else {
			return;
		}
	}

}
