/**
 * Some other interpolation from numerical recepies.
 * \file polint.cpp
 */

//#include "../../Logging/Output.h"
#include "math.h"
#include <malloc/malloc.h>
#include <stdlib.h>
#include <cstdio>

/**
 * Some other interpolation from numerical recepies.
 */
void polint( double *xa, double *ya, int n, double x, double *y, double *dy )
{
    double *c = NULL;
    double *d = NULL;
    double den;
    double dif;
    double dift;
    double ho;
    double hp;
    double w;

    int i;
    int m;
    int ns;

    if( (c = (double *)malloc( n * sizeof( double ) )) == NULL || (d = (double *)malloc( n * sizeof( double ) )) == NULL ) {
        //fprintf( stderr, "polint error: allocating workspace\n" );
		//Output::echo(0, "polint error: allocating workspace\n" );
        //fprintf( stderr, "polint error: setting y = 0 and dy = 1e9\n" );
		//Output::echo(0, "polint error: setting y = 0 and dy = 1e9\n" );
        *y = 0.0;
        *dy = 1.e9;

		if( c != NULL )
            free( c );
        if( d != NULL )
            free( d );
        return;
    }

    ns = 0;
    dif = fabs(x-xa[0]);
    for( i = 0; i < n; ++i ) {
        dift = fabs( x-xa[i] );
        if( dift < dif ) {
            ns = i;
            dif = dift;
        }
        c[i] = ya[i];
        d[i] = ya[i];
    }
    *y = ya[ns];
    ns = ns-1;
	//if (ns < 0) ns = 0; ////////////////
    for( m = 0; m < n-1; ++m ) {
        for( i = 0; i < n-m-1; ++i ) {
            ho = xa[i]-x;
            hp = xa[i+m+1]-x;
            w = c[i+1]-d[i];
            den = ho-hp;
            if( fabs(den) < 1.e-25 ) {
                fprintf( stderr, "polint error: den = 0\n" );
				//Output::echo(0, "polint error: den = 0\n" );
                fprintf( stderr, "polint error: setting y = 0 and dy = 1e9\n" );
				//Output::echo(0, "polint error: setting y = 0 and dy = 1e9\n" );
				exit(0);
                *y = 0.0;
                *dy = 1.e9;

                if( c != NULL )
                    free( c );
                if( d != NULL )
                    free( d );
                return;
            }
            den = w/den;
            d[i] = hp*den;
            c[i] = ho*den;
        }
        if( 2*(ns+1) < n-m-1 ) {
            *dy = c[ns+1];
        } else {
            *dy = d[ns];
            ns = ns-1;
			//if (ns < 0) ns = 0; //////////
        }
        *y = (*y)+(*dy);
    }


    if( c != NULL )
        free( c );
    if( d != NULL )
        free( d );
    return;
}
