/**
 * Some other  interpolation
 * \file ratint.cpp
 */

//#include <iostream>
#include "ratint.h"
#include "math.h"
#include "../../Exceptions/error.h"

#define TINY 1.0e-25

/**
 * Some other  interpolation
 */
void ratint(double *xa, double *ya, int n, double x, double *y, double *dy)
{
	int m,i,ns=1;
	double w,t,hh,h,dd,*c,*d;

	c = new double[n];//vector(1,n);
	d = new double[n];//vector(1,n);
	hh=fabs(x-xa[0]);
	for (i=0;i<=n-1;i++) {
		h=fabs(x-xa[i]);
		if (h == 0.0) {
			*y=ya[i];
			*dy=0.0;
			return;
		} else if (h < hh) {
			ns=i;
			hh=h;
		}
		c[i]=ya[i];
		d[i]=ya[i]+TINY;
	}
	*y=ya[ns--];
	for (m=0;m<n-1;m++) {
		for (i=0;i<n-m;i++) {
			w=c[i+1]-d[i];
			h=xa[i+m]-x;
			t=(xa[i]-x)*d[i]/h;
			dd=t-c[i+1];
			if (dd == 0.0) {
				//printf("Error in routine ratint");
				//exit(0);
				throw error_msg("RATINT_ERROR", "Error in routine ratint");
			}
			dd=w/dd;
			d[i]=c[i+1]*dd;
			c[i]=t*dd;
		}
		*y += (*dy=(2*ns < (n-m) ? c[ns+1] : d[ns--]));
	}
	return;
}
