/**
 * Bisection method of root finding code
 *  
 * \file bisection.cpp
 * 
 * \author Unknown (Numeric recepies?)
 */


#include <assert.h>
#include <math.h>
#include "bisection.h"

/**
 * \brief Looking for roots of function f for given Alpha on the interval x0-x1
 * \param (*f), - Function for root finding. Only x-roots are finded, Alpha is constant  
 * \param Alpha,  - constant for the f function
 * \param x0 = -1E+7, - left boundary of the interval
 * \param x1 = 1E+7, - right boundary of the interval
 * \param eps = max_error); - max error
 */
double bisection (double (*f)(double x, double Alpha), double Alpha, double x0, double x1, double eps) {

	// assert... some sort of checking and notifiyng
	assert(x0 < x1);

	double x;
	do {

		x = (x0 + x1) / 2;
		double y0 = f(x0, Alpha), yy = f(x, Alpha);

		if (yy * y0 < 0) x1 = x;
		else
			if (yy * y0 > 0) x0 = x;
			else
				return x;

	} while (fabs(x1 - x0) > eps);

	return x;

}
