/**
 * Bisection method of root finding header
 * 
 * \file bisection.h
 * 
 * \author Unknown (Numeric recepies?)
 */

#ifndef BISECTION_H
#define BISECTION_H

/// define max_error maximum error after calculation
#define max_error 1E-15

/**
 * \brief Looking for roots of function f for given Alpha on the interval x0-x1
 * \param (*f), - Function for root finding. Only x-roots are finded, Alpha is constant  
 * \param Alpha,  - constant for the f function
 * \param x0 = -1E+7, - left boundary of the interval
 * \param x1 = 1E+7, - right boundary of the interval
 * \param eps = max_error); - max error
 */
double bisection (
	double (*f)(double x, double Alpha),	  
	double Alpha, 										
	double x0 = -1E+7,								
	double x1 = 1E+7, 								
	double eps = max_error);						

#endif
