/**
 * \file erf.h
 *  Error function.
 * 
 * \author Numerical recepies.
 */

#include <math.h>

///Maximum allowed number of iterations.
#define ITMAX 100000
///Relative accuracy.
#define EPS 3.0e-7 
///Number near the smallest representable doubleing-point number.
#define FPMIN 1.0e-30 

//void nrerror(const char *msg);

double gammln(double xx);

double gammp(double a, double x);

double gammq(double a, double x);

void gser(double *gamser, double a, double x, double *gln);

void gcf(double *gammcf, double a, double x, double *gln);

double erf(double x);
