addpath('./Various_scripts')

clear all;
%close all

path_file_arr = [

    {'../Execute/Output/'}        
    %{'../10keV-noint-180/NoMT_Maxwellian/Hiss_10pT_48hr/Output/'}        
    
    ];

%c_min = -14;
%c_max = -7;
c_min = -2;
c_max = 2;


target_L = 2.4;
target_energy = 0.0180;
DOY_start=0;%293;

cl = nan; cl2 = nan;
for i = 1:length(path_file_arr)
    path_file = path_file_arr{i}
    
    gridFileName = [path_file, 'perp_grid.plt'];
    dataFileName = [path_file, 'OutPSD.dat'];
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %gridFileName = [path_file, 'rad_grid.plt'];
    %dataFileName = [path_file, 'OutPSD_rad.dat'];
    
    oneDimDataFileName = [path_file, 'out1d.dat'];
    
    [L, epc, alpha, pc] = load_plt(gridFileName, 'squeeze', 'permute', 'make3D');
    [time, Kp, Bf, Lpp] = load_plt(oneDimDataFileName);
    
    % to read PSD only once, and then save it as .mat file
    try
        a(-1)
        %delete([dataFileName, '.mat'])
        load([dataFileName, '.mat'])
    catch
        PSD = load_plt(dataFileName, 'permute', 'nosqueeze', 'n_zones', 99999, 'skip_zones', 0);%
        save([dataFileName, '.mat'], 'PSD')
    end
    units_constant = 1/(3e7); % (c/MeV/cm)^3 after that
    PSD.arr = PSD.arr*units_constant;
    
    PSD.time = PSD.time + DOY_start;
    
    [val, L_slice] = min(abs(L.arr(:,1,1) - target_L));
    [val, E_slice] = min(abs(squeeze(epc.arr(1,:,1)) - target_energy));
    
    alpha_1d = squeeze(alpha.arr(L_slice,E_slice,:))./pi.*180;

    f1 = figure('Units', 'inches', 'Position', [0.5 0.5 12 5], ...
        'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 12, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 12,...
        'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%
    
    set(gcf, 'Name', path_file);
    
    cmap = jet(length(PSD.time));
    colormap(cmap);
    
    set(gca,'nextplot','replacechildren','ColorOrder',cmap,'Box','on');
    PSD_1d = squeeze(PSD.arr(:,L_slice,E_slice,:))';
    
    % normalize
    PSD_1d = PSD_1d./max(PSD_1d(1,:));
    
    plot(alpha_1d, PSD_1d);
    set(gca, 'yscale', 'log');
    
    xlim([0 180])
    ylim([10^c_min 10^c_max])

    caxis([PSD.time(1) PSD.time(end)])
    colorbar
    
    xlabel('Pitch angle, deg')
    ylabel('PSD');
    
    save_picture(gcf, [path_file, '../Plots/PSD_1d_L=', num2str(L.arr(L_slice,E_slice,1)), '_E=', num2str(epc.arr(L_slice,E_slice,1))], 'jpg', 'pdf', 'eps'); 


end

return

