clear all

% number of colors
n_c = 50;

% if you want to plot mixed terms set to trur
mix = true

% This is an alphabet ;)
alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';

% path to the diffusion coefficients
path1 = '../!Diffusion_coefficients/2009-10-30 Full, MT Recalc 3D/';  % Chorus
path2 = '../!Diffusion_coefficients/2009-02-26 Full, Inner belt 3D/'; % VLF, LIW. Plasmaspheric hiss here only for L<4
%path3 = '../!Diffusion_coefficients/2010-04-26 Plasmaspheric hiss/';  % Plasmaspheric hiss
path4 = '../!Diffusion_coefficients/2010-11-05 Hiss/';  % Recalculated (mode accurate) hiss, L<5.5
path5 = '../!Diffusion_coefficients/2011-04-15 Hiss and Lightning/Hiss/L1.5/';
path6 = '../!Diffusion_coefficients/2011-04-15 Hiss and Lightning/Lightning/L1.5/';

Dxx_file_arr = {
    %%%>>>  path - file - MLT - scale (for correct Bw for Kp=4) <<<%%%
%    {[path1, 'FullCode_DaysideChorus_BavD_Matrix_091030.txt'], '', '', ChorusScale, 'chorus_day'},
%    {[path1, 'FullCode_NightsideChorus_BavD_Matrix_091030.txt'], '', '', ChorusScale, 'chorus_night'},

    %{[path4, 'PlasmasphericHiss_BavD_Matrix_L1to55_thetam0.txt'], '', '', 1, 'hiss_pp_new'}, % 40 pT

    {[path2, 'LightninginducedWhistler_InnerBelt_BavD_Matrix_NEW1.txt'], '', '', 1, 'LIW'}, % 1 pT
    {[path2, 'VLFTransmitter1_InnerBelt_BavD_Matrix_NEW1.txt'], '', '', 1, 'VT1'},
    {[path2, 'VLFTransmitter2_InnerBelt_BavD_Matrix_NEW1.txt'], '', '', 1, 'VT2'},
    
    %2d 
    %{[path5, 'PlasmasphericHiss_BavD_Matrix_L1_5_thetam0.txt'], '', '', 1, 'hiss_pp'}, %40 pT
    %{[path6, 'Lightning_BavD_Matrix_L15_thetam45.txt'], '', '', 1, 'LIW'}, %3 pT

};


% some parameters
letters_size = 10;
letters_color = 'white';
name_size = 10;
name_color = 'white';

% specigy at wahat L you want to plot (for 3D)
L_val = 3;

min_c = -8;
max_c = -2;
y_min = 1e-2;
y_max = 1e1;

% load
Dxx_num = length(Dxx_arr);
for Dxx_i = 1:Dxx_num
    if (strcmp(Dxx_arr{Dxx_i}{4}, 'VERB'))
        [L{Dxx_i}, epc{Dxx_i}, alpha{Dxx_i}, Daa{Dxx_i}] = load_plt([path1, Dxx_arr{Dxx_i}{1}], 'squeeze');
        [L{Dxx_i}, epc{Dxx_i}, alpha{Dxx_i}, Dpp{Dxx_i}] = load_plt([path1, Dxx_arr{Dxx_i}{2}], 'squeeze');
        if (mix) [L{Dxx_i}, epc{Dxx_i}, alpha{Dxx_i}, Dpa{Dxx_i}] = load_plt([path1, Dxx_arr{Dxx_i}{3}], 'squeeze'); end;
    elseif (strcmp(Dxx_arr{Dxx_i}{4}, 'Binbin'))
        [L{Dxx_i}, epc{Dxx_i}, alpha{Dxx_i}, Daa{Dxx_i}, Dpp{Dxx_i}, Dpa{Dxx_i}] = load_plt([path1, Dxx_arr{Dxx_i}{1}], 'squeeze');
        epc{Dxx_i}.arr = epc{Dxx_i}.arr./1e3; % keV to MeV
        alpha{Dxx_i}.arr = alpha{Dxx_i}.arr.*pi./180;
    elseif (strcmp(Dxx_arr{Dxx_i}{4}, 'OLD')) % OLD FORMAT, with (alpha - energy - L) columns in the file, instead of new (L - energy - alpha)
        [alpha{Dxx_i}, epc{Dxx_i}, L{Dxx_i}, Daa{Dxx_i}] = load_plt([path1, Dxx_arr{Dxx_i}{1}], 'squeeze', 'nopermute');
        [alpha{Dxx_i}, epc{Dxx_i}, L{Dxx_i}, Dpp{Dxx_i}] = load_plt([path1, Dxx_arr{Dxx_i}{2}], 'squeeze', 'nopermute');
        if (mix) [alpha, epc, L, Dpa{Dxx_i}] = load_plt([path1, Dxx_arr{Dxx_i}{3}], 'squeeze', 'nopermute'); end;
    else
        'Error1'
        return;
    end

    try % Multiply by the scaling coefficient
        Daa{Dxx_i}.arr = Daa{Dxx_i}.arr * Dxx_arr{Dxx_i}{6};
        Dpp{Dxx_i}.arr = Dpp{Dxx_i}.arr * Dxx_arr{Dxx_i}{6};
        if (mix) Dpa{Dxx_i}.arr = Dpa{Dxx_i}.arr * Dxx_arr{Dxx_i}{6}; end
    catch end

    % make 2D from 3D
    if (length(size(Daa{Dxx_i}.arr)) >= 3)
        L_slice = min(find(L{Dxx_i}.arr(:,1,1)>=L_val));
        L{Dxx_i}.arr(L_slice,1,1)

        epc_2d{Dxx_i} = squeeze(epc{Dxx_i}.arr(L_slice, :,:));
        alpha_2d{Dxx_i} = squeeze(alpha{Dxx_i}.arr(L_slice, :,:))*180/pi;

        Daa_2d{Dxx_i} = squeeze((Daa{Dxx_i}.arr(L_slice,:,:)));
        Dpp_2d{Dxx_i} = squeeze((Dpp{Dxx_i}.arr(L_slice,:,:)));
        if (mix)
            Dpa_2d{Dxx_i} = squeeze((Dpa{Dxx_i}.arr(L_slice,:,:)));
        end;

    else
        L_slice = 1;
        epc_2d{Dxx_i} = (epc{Dxx_i}.arr(:,:));
        alpha_2d{Dxx_i} = (alpha{Dxx_i}.arr(:,:))*180/pi;

        Daa_2d{Dxx_i} = ((Daa{Dxx_i}.arr(:,:)));
        Dpp_2d{Dxx_i} = ((Dpp{Dxx_i}.arr(:,:)));
        if (mix)
            Dpa_2d{Dxx_i} = ((Dpa{Dxx_i}.arr(:,:)));
        end;
    end;
end;

f1 = figure('Units', 'inches','Position', [0.0 0.0 8.5 5.5],... %1+2*Dxx_num], ...
    'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 10, ...
    'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%

set(gcf, 'name', [path1, Dxx_arr{Dxx_i}{1}, ', L=', num2str(L{Dxx_i}.arr(L_slice,1,1))])

if (mix)
%    subplot1(Dxx_num, 4, 'Min', [0.1,0.05+0.1/Dxx_num], 'Max', [0.9,0.95]);
    subplot1(Dxx_num, 5, 'Min', [0.1,0.1+0.1/Dxx_num], 'Max', [0.95,0.9]);
else
    subplot1(Dxx_num, 2, 'Min', [0.1,0.1+0.1/Dxx_num], 'Max', [0.9,0.9]);
end

pic_i = 0;

for Dxx_i = 1:Dxx_num
    pic_i=pic_i+1;
    subplot1(pic_i);
    Dplot = log10(Daa_2d{Dxx_i});
    Dplot(find(~isfinite(Dplot)))=min_c; Dplot(isnan(Dplot)) = min_c;
    Dplot(find(Dplot<min_c))=min_c; Dplot(find(Dplot>max_c)) = max_c;
    %contourf(alpha_2d{Dxx_i}, epc_2d{Dxx_i}, Dplot, n_c);
    pcolor(alpha_2d{Dxx_i}, epc_2d{Dxx_i}, Dplot);
    shading flat; set(gca,'Yscale','log'); caxis([min_c max_c]);
    xlim([0 90]); ylim([y_min y_max]);
    ylabel({Dxx_arr{Dxx_i}{5}, 'Energy, MeV'});
    if (Dxx_i == 1) title('D_{\alpha \alpha}'); end;
    if (Dxx_i == Dxx_num) xlabel('Pitch angle, deg'); end;
    text(max(xlim), max(ylim), [alphabet(Dxx_i), '1'], 'VerticalAlignment', 'top', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', letters_size, 'Color', letters_color);
    %  text(min(xlim), max(ylim), {' D_{\alpha \alpha} ', ''}, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'left', 'FontWeight', 'bold', 'FontSize', name_size, 'Color', name_color);

    set(gca, 'yTick', [0.1, 1, 10])
    
    pic_i=pic_i+1;
    subplot1(pic_i);
    ic = pic_i;
    Dplot(:,:) = log10(Dpp_2d{Dxx_i});
    Dplot(find(~isfinite(Dplot)))=min_c; Dplot(isnan(Dplot)) = min_c;
    Dplot(find(Dplot<min_c))=min_c; Dplot(find(Dplot>max_c)) = max_c;
    %contourf(alpha_2d{Dxx_i}, epc_2d{Dxx_i}, Dplot, n_c);
    pcolor(alpha_2d{Dxx_i}, epc_2d{Dxx_i}, Dplot);
    shading flat; set(gca,'Yscale','log'); caxis([min_c max_c]);
    xlim([0 90]); ylim([y_min y_max]);
    if (Dxx_i == 1) title('D_{pp}/p^2'); end;
    if (Dxx_i ==Dxx_num) xlabel('Pitch angle, deg'); end;
    text(max(xlim), max(ylim), [alphabet(Dxx_i), '2'], 'VerticalAlignment', 'top', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', letters_size, 'Color', letters_color);
    %  text(min(xlim), max(ylim), {' D_{pp}/p^2 ', ''}, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'left', 'FontWeight', 'bold', 'FontSize', name_size, 'Color', name_color);
    cb_axis = gca;
    
    if (mix)
        pic_i=pic_i+1;
        subplot1(pic_i);
        ic = pic_i;
        Dplot(:,:) = log10(abs(Dpa_2d{Dxx_i}));
        Dplot(find(~isfinite(Dplot)))=min_c; Dplot(isnan(Dplot)) = min_c;
        Dplot(find(Dplot<min_c))=min_c; Dplot(find(Dplot>max_c)) = max_c;
        %contourf(alpha_2d{Dxx_i}, epc_2d{Dxx_i}, Dplot, n_c);
        pcolor(alpha_2d{Dxx_i}, epc_2d{Dxx_i}, Dplot);
        shading flat; set(gca,'Yscale','log'); caxis([min_c max_c]);
        xlim([0 90]); ylim([y_min y_max]);
        if (Dxx_i == 1) title('|D_{p \alpha}|/p'); end;
        if (Dxx_i ==Dxx_num) xlabel('Pitch angle, deg'); end;
        text(max(xlim), max(ylim), [alphabet(Dxx_i), '3'], 'VerticalAlignment', 'top', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', letters_size, 'Color', letters_color);
        %    text(min(xlim), max(ylim), {' |D_{p \alpha}|/p ', ''}, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'left', 'FontWeight', 'bold', 'FontSize', name_size, 'Color', name_color);
        cb_axis = gca;
        
        pic_i=pic_i+1;
        subplot1(pic_i);
        delete(gca);

        %pic_i=pic_i+1;
        subplot1(pic_i);
        Dplot(:,:) = sign(Dpa_2d{Dxx_i});
        pcolor(alpha_2d{Dxx_i}, epc_2d{Dxx_i}, Dplot);
        shading flat; set(gca, 'yScale', 'log'); caxis([-1 1])
        xlim([0 90]); ylim([y_min y_max]);
        if (Dxx_i == 1) title('sign(D_{p \alpha})'); end;
        if (Dxx_i ==Dxx_num) xlabel('Pitch angle, deg'); end;
        text(max(xlim), max(ylim), [alphabet(Dxx_i), '4'], 'VerticalAlignment', 'top', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'FontSize', letters_size, 'Color', letters_color);    
        %    text(min(xlim), max(ylim), {' sigh(D_{p \alpha}) ', ''}, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'left', 'FontWeight', 'bold', 'FontSize', name_size, 'Color', name_color);


        set(gca, 'yTickLabelMode', 'auto', 'yTick', [0.1, 1, 10])
        
    end
    
    % color bar
    ax_pos4 = get(cb_axis, 'Position');
    subplot1(ic)
    text(max(xlim)+5, 10^((min(log10(ylim)) + max(log10(ylim)))/2), 'log_10{days^{-1}}', 'Rotation', 90, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'center', 'FontWeight', 'bold');    
    cl = colorbar('West');
    cl_pos = get(cl, 'Position');
    cl_x_pos = ax_pos4(1) + ax_pos4(3) + 0.035;%0.015; %0.925
%    set(cl, 'Position', [cl_x_pos, cl_pos(2), cl_pos(3), cl_pos(4)]);
    set(cl, 'Position', [cl_x_pos, ax_pos4(2), cl_pos(3), ax_pos4(4)]);

    
end

save_picture(gcf, ['DiffCoeff_L=', num2str(L{Dxx_i}.arr(L_slice, 1, 1))], 'jpg', 'pdf', 'epsc');

return


figure
hold on
plot(alpha{1}.arr(E_slice, :)*180/pi, Daa{1}.arr(E_slice, :), 'r')
plot(alpha{1}.arr(E_slice, :)*180/pi, Dpp{1}.arr(E_slice, :), 'g')
plot(alpha{1}.arr(E_slice, :)*180/pi, abs(Dpa{1}.arr(E_slice, :)), 'b')
set(gca, 'yscale', 'log')
legend('Daa', 'Dpp', '|Dpa|')
plot([90 90], ylim, '--k')

xlabel('Pitch angle, deg')
ylabel('Diffusion coefficient')

save_picture(gcf, ['DiffCoeff_1d_L=', num2str(L{1}.arr(E_slice, 1)), '_E=', num2str(epc{1}.arr(E_slice, 1))], 'jpg', 'pdf', 'epsc');


