%%
clear all;
%close all;
addpath('.\Various_scripts')

DOY_start=239; % day of the year of the first day of simulation


path_arr = [
    {'../Execute/Output/'},
    ];

pic_n = 3;
TextColor = 'white';
TextColor1 = 'white';

% output parameters:
output_formats = [{'fig'}, {'epsc'}, {'pdf'}];
FontSize = 9;
n_colors = 80;


for pic = 1:length(path_arr)
    path1 = path_arr{pic};

    %c_min = 1;
    %c_max = 6;
    %target_epc = [0.1];

    %c_min = 1;
    %c_max = 7;
    %target_epc = [0.5];

    c_min =0 ;
    c_max = 6.6;
    target_epc = [2.2];

    target_alpha = [35];

    units_constant = 1;%3*10^-2; % units 10^-6*(c/MeV/cm)^3 after that

    %----------------------------------------------------------------------
    %---



    gridFileName = [path1, 'perp_grid.plt'];
    dataFileName = [path1, 'OutPSD.dat'];
    %%%%%%%%%%%%%%%%%%%%%%%%%%%
    % dataFileName = [path1, 'OutPSD_rad.dat'];
    % gridFileName = [path1, 'rad_grid.plt'];

    if (gridFileName(length(gridFileName)-3:length(gridFileName)) == '.dat')
        [alpha, epc, L, pc] = load_plt(gridFileName, 'squeeze', 'permute');
    else
        [L, epc, alpha, pc] = load_plt(gridFileName, 'squeeze', 'permute');
    end;

    target_L = L.arr(:,1,1);
    [new_L, new_epc, new_alpha] = meshgrid(target_L, target_epc, target_alpha/180*pi);
    new_pc = pfunc(new_epc);

    PSD = load_plt(dataFileName, 'permute', 'n_zones', 9999);%, 'skip_zones', 3);%
    PSD.arr = PSD.arr*units_constant;

    oneDimDataFileName = [path1, 'out1d.dat'];
    [time, Kp, Bf, Lpp, Bw2] = load_plt(oneDimDataFileName);
    time_arr = PSD.time+DOY_start;
    size_time=length(time_arr);
    size_L=epc.size1;
    size_epc=epc.size2;
    size_alpha=epc.size3;
    for it = 1: size(PSD.arr,1) %time.size1
        Flux(it, :, :, :) = squeeze(PSD.arr(it, :, :, :)) .* pc.arr(:, :, :) .* pc.arr(:, :, :);
    end
    Flux_L_E=zeros(size_time, size_L, size_epc);
    %%
    for it=1:1:size_time
        for iL=1:1:size_L
            for ie=1:1:size_epc
                index_alpha=find(alpha.arr(iL,ie,:)<target_alpha*pi/180);
                new_index=index_alpha-1;
                new_index(1)=new_index(length(1))+1;
                Flux_L_E(it,iL,ie)=sum(   squeeze (Flux(it,iL,ie,index_alpha)) .*  squeeze(alpha.arr(iL,ie,index_alpha)-alpha.arr(iL,ie,new_index))   );
            end
        end
        it
    end

    Flux_L=zeros(size_time, size_L );
    for it=1:1:size_time
        for iL=1:1:size_L
            index_energy=find(epc.arr(iL,:,1)>target_epc);
            % for ie=index_energy:1:size_epc
            %Flux_L(it,iL)=Flux_L(it,iL)+ Flux_L_E(it,iL,index_energy).*epc.arr(it,iL,index_energy) ;
            %end
            new_index=index_energy+1;
            new_index(length(new_index))=new_index(length(new_index))-1;

            energy_above=sqrt(squeeze(Flux_L_E(it,iL,index_energy) )'.* squeeze(Flux_L_E(it,iL,new_index) )' )
            Flux_L(it,iL)=(-1e3)*sum(energy_above.*(   squeeze(epc.arr(iL,index_energy, 1))-squeeze(epc.arr(iL,new_index, 1))  ) ) ;
        end
        it
    end


    %     new_Flux_arr{pic}.arr = fast_interpolate(L.arr, epc.arr, alpha.arr, Flux, new_L, new_epc, new_alpha, 'log');
    %     new_Flux = new_Flux_arr{pic}.arr;
    %    eval(['save ', [path1, 'Flux_E=', num2str(target_epc), '_alpha', num2str(target_alpha)], ' new_L time_arr new_Flux'])


    %--------------------------------------------------------------------------

    %time_arr = time_arr + datenum('21-04-2001', 'dd-mm-yyyy') - datenum('00-04-2001', 'dd-mm-yyyy');

    %PSD_max = 10^c_max
    %PSD_max = 10^max(max(max(max(new_PSD([3:time.size1],:,:,:))))) - 0.2;
    %c_max = log10(max(max(max(max(new_PSD(:,:,:,:))))));
    Flux_min = 10^c_min;%Flux_max - 10^delta_color;
    Flux_L(find(Flux_L<Flux_min))=Flux_min;
    log_Flux = log10(Flux_L);

    f1 = figure('Units', 'inches', 'Position', [0.5 0.5 7 4], ...
        'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 12, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 12,...
        'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%

    cmap = colormap;
    cmap(1,:);
    cmap(1,:) = [0 0 0];
    colormap(cmap)
    contourf(time_arr, new_L, log_Flux', n_colors);
    shading flat
    axis tight
    ylim([1 7]);
    caxis([c_min c_max]);
    colorbar
    text(max(xlim), (min(ylim) + max(ylim))/2, 'Flux, log(#/sr/s/cm^2/KeV)', 'Rotation', 90, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'center', 'FontWeight', 'bold');
    %text(max(xlim), (min(ylim) + max(ylim))/2, '-3 \cdot 10^{-8} (c/MeV/cm)^3', 'Rotation', 90, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'center', 'FontWeight', 'bold');
    %xlabel('Time, day of Apr. 2001');
    xlabel('Time, days');
    ylabel('L*');
    if (target_alpha >= 88)
        text(max(xlim), min(ylim), {['Energy = ', num2str(target_epc), ' MeV, equatorial pitch angle ']}, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'color', TextColor);
    else
        text(max(xlim), min(ylim), {['Energy = ', num2str(target_epc), ' MeV, Pitch angle = ', num2str(target_alpha), '^o ']}, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'right', 'FontWeight', 'bold', 'color', TextColor);
    end

    hold on
    plot(time.arr, Lpp.arr, 'w');
    plot(time.arr, Kp.arr, '--w');
    figure()
    plot(time.arr, Lpp.arr, ':', 'color', 'red', 'Linewidth', 2);
    hold on
    plot(time.arr, Kp.arr, '--', 'color', 'blue', 'Linewidth', 2);
    title([{path1}, {' '}]);
    set(gcf, 'Name', path1);

    save_picture(gca, [path1, '../Plots/Flux_E=', num2str(target_epc), '_alpha', num2str(target_alpha), '_', num2str(c_max)], 'jpg', 'pdf', 'epsc', 'fig');

    %close(f1)
    if (false)

        c_min = -2;
        c_max = 7.4
        Flux_L_top = squeeze(PSD.arr(:, PSD.size1, :, PSD.size3));
        Flux_min = 10^c_min;
        Flux_L_top(find(Flux_L_top<Flux_min))=Flux_min;
        log_Flux = log10(Flux_L_top);

        f1 = figure('Units', 'inches', 'Position', [0.5 0.5 7 4], ...
            'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 12, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 12,...
            'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%

        cmap = colormap;
        cmap(1,:);
        cmap(1,:) = [0 0 0];
        colormap(cmap)
        contourf(time_arr, squeeze(epc.arr(PSD.size1, :, PSD.size3)), log_Flux', n_colors);
        shading flat
        axis tight
        set(gca, 'yscale', 'log');
        ylim([1e-1 6e0]);
        caxis([c_min c_max]);
        colorbar
        text(max(xlim), 10.^((log10(min(ylim)) + log10(max(ylim)))/2), 'Flux, log(#/sr/s/cm^2/KeV)', 'Rotation', 90, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'center', 'FontWeight', 'bold');
        %text(max(xlim), (min(ylim) + max(ylim))/2, '-3 \cdot 10^{-8} (c/MeV/cm)^3', 'Rotation', 90, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'center', 'FontWeight', 'bold');
        %xlabel('Time, day of Apr. 2001');
        xlabel('Time, days');
        ylabel('Energy, MeV');

        save_picture(gca, [path1, '../Plots/Flux_L_top'], 'jpg', 'pdf', 'epsc', 'fig');

    end

end;


return

figure
plot(new_L, new_Flux(1, :));
hold on;
plot(new_L, new_Flux(1, :));


return

f1 = figure('Units', 'inches', 'Position', [0.5 0.5 2 2], ...
    'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 12, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 12,...
    'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%
plot(time.arr, Bf.arr, 'k', 'LineWidth', 2);
ylim([0 1.1])
xlabel('Time, days')
ylabel('Boundary flux')
save_picture(gca, [path1, 'Bf'], 'jpg', 'pdf', 'epsc', 'fig');

